#SingleInstance, force
#Persistent
#include vjoy_lib.ahk

; Set the vjoy id of the stick to control
vjoy_id := 1

; Init the vJoy stick
vjoy_init(vjoy_id)

; Check X axis exists on stick
if (!VJoy_GetAxisExist_X(vjoy_id)){
	msgbox Please enable the X axis of vjoy ID %vjoy_id% using the vJoy config utility.
}

xofs := 0
yofs := 0

precision := 150

calibration := 0

mouse_adjusted := false

SetCapsLockState AlwaysOff

BlockInput Mouse
SetMouseDelay -1

SetTimer WatchMouse, 1
SetTimer UpdateAxes, 50

CapsLock & Left::
    VJoy_SetAxis(1, vjoy_id, HID_USAGE_X)
    VJoy_SetAxis(1, vjoy_id, HID_USAGE_Y)
Return

CapsLock & Right::
    VJoy_SetAxis(32767, vjoy_id, HID_USAGE_X)
    VJoy_SetAxis(32767, vjoy_id, HID_USAGE_Y)
Return

CapsLock & Up::
    VJoy_SetAxis(16384, vjoy_id, HID_USAGE_X)
    VJoy_SetAxis(16384, vjoy_id, HID_USAGE_Y)
Return

WatchMouse:
    if (GetKeyState("ScrollLock", "T"))
    {
        SysGet, screenx, 76
        SysGet, screeny, 77
        SysGet, screenwidth, 78
        SysGet, screenheight, 79

        x0 := screenx + screenwidth / 2
        y0 := screeny + screenheight / 2

        MouseGetPos x, y
        if (mouse_adjusted)
        {
            xofs := xofs + x - x0
            yofs := yofs + y - y0
        }
        else
        {
            mouse_adjusted := true
        }
        
        MouseMove x0, y0, 0
    }
    else
    {
        mouse_adjusted := false
    }
Return

UpdateAxes:
    if (GetKeyState("ScrollLock", "T"))
    {
        if (xofs > precision)
        {
            VJoy_SetAxis(32767, vjoy_id, HID_USAGE_X)
            xofs := xofs - precision
        }
        else if (xofs < -precision)
        {
            VJoy_SetAxis(0, vjoy_id, HID_USAGE_X)
            xofs := xofs + precision
        }
        else
        {
            xval := (xofs * 16383 / precision) + 16384
            VJoy_SetAxis(xval, vjoy_id, HID_USAGE_X)
            xofs := 0
        }

        if (yofs > precision)
        {
            VJoy_SetAxis(32767, vjoy_id, HID_USAGE_Y)
            yofs := yofs - precision
        }
        else if (yofs < -precision)
        {
            VJoy_SetAxis(0, vjoy_id, HID_USAGE_Y)
            yofs := yofs + precision
        }
        else
        {
            yval := (yofs * 16383 / precision) + 16384
            VJoy_SetAxis(yval, vjoy_id, HID_USAGE_Y)
            yofs := 0
        }
    }
    else
    {
        VJoy_SetAxis(16383, vjoy_id, HID_USAGE_X)
        VJoy_SetAxis(16383, vjoy_id, HID_USAGE_Y)
    }
Return

LButton::
    if (GetKeyState("ScrollLock", "T"))
    {
        VJoy_SetBtn(1, vjoy_id, 1)
    }
    else
    {
        Send, {LButton Down}
    }
Return

LButton Up::
    if (GetKeyState("ScrollLock", "T"))
    {
        VJoy_SetBtn(0, vjoy_id, 1)
    }
    else
    {
        Send, {LButton Up}
    }
Return

RButton::
    if (GetKeyState("ScrollLock", "T"))
    {
        VJoy_SetBtn(1, vjoy_id, 2)
    }
    else
    {
        Send, {RButton Down}
    }
Return

RButton Up::
    if (GetKeyState("ScrollLock", "T"))
    {
        VJoy_SetBtn(0, vjoy_id, 2)
        xofs := 0
    }
    else
    {
        Send, {RButton Up}
    }
Return

MButton::
    if (GetKeyState("ScrollLock", "T"))
    {
        VJoy_SetBtn(1, vjoy_id, 3)
    }
    else
    {
        Send, {MButton Down}
    }
Return

MButton Up::
    if (GetKeyState("ScrollLock", "T"))
    {
        VJoy_SetBtn(0, vjoy_id, 3)
    }
    else
    {
        Send, {LButton Up}
    }
Return

WheelDown::
    if (GetKeyState("ScrollLock", "T"))
    {
        Send, Y
    }
    else
    {
        Send, {WheelDown}
    }
Return

WheelUp::
    if (GetKeyState("ScrollLock", "T"))
    {
        Send, T
    }
    else
    {
        Send, {WheelUp}
    }
Return

